// AviSearchingTimeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AviSearchingTime.h"
#include "AviSearchingTimeDlg.h"

#include "direct.h"
#include "Vfw.h"
#include "ximage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAviSearchingTimeDlg dialog

CAviSearchingTimeDlg::CAviSearchingTimeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAviSearchingTimeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAviSearchingTimeDlg)
	m_strFrameMid = _T("");
	m_strFrameMax = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	this->byBeginFlag=0;
	m_pAviFile=NULL;
}

void CAviSearchingTimeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAviSearchingTimeDlg)
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
	DDX_Control(pDX, IDC_SLIDER1, m_SliderBar);
	DDX_Text(pDX, IDC_STATIC3, m_strFrameMid);
	DDX_Text(pDX, IDC_STATIC2, m_strFrameMax);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAviSearchingTimeDlg, CDialog)
	//{{AFX_MSG_MAP(CAviSearchingTimeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER1, OnCustomdrawSlider1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAviSearchingTimeDlg message handlers

BOOL CAviSearchingTimeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAviSearchingTimeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAviSearchingTimeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAviSearchingTimeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAviSearchingTimeDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here

	CString strAviFileName;

	CFileDialog *dlgOpenFile = new CFileDialog(TRUE,NULL,NULL,
		OFN_HIDEREADONLY,
		"avi Files (*.avi)|*.avi|All Files (*.*)|*.*||",NULL);

	if(dlgOpenFile->DoModal()==TRUE)
	{

		strAviFileName.Format("%s",dlgOpenFile->GetPathName());

	}

	AviInit(strAviFileName);

	m_ListBox.ResetContent();
	m_SliderBar.SetRange(0,m_pAviFileInfo.dwLength-1);
	m_SliderBar.SetPos(0);
	m_strFrameMax.Format("%ld",m_pAviFileInfo.dwLength-1);
	UpdateData(FALSE);

	ShowImage(0);
	
}


void CAviSearchingTimeDlg::OnCustomdrawSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	if(this->byBeginFlag!=0)
	{
		int iSliderPos=m_SliderBar.GetPos();
		if(iSliderPos!=m_iSliderPos && m_pAviFile!=NULL)
		{
			m_iSliderPos=iSliderPos;

			m_strFrameMid.Format("%d",m_iSliderPos);			
			this->UpdateData(FALSE);

			CString strTemp;
			clock_t StartTime, FinishTime;
			double  Duration;
			StartTime = clock();

			ShowImage((long)m_iSliderPos);

			FinishTime = clock();
			Duration = (double)(FinishTime - StartTime)/ CLOCKS_PER_SEC;
			strTemp.Format("searching time=%lf",Duration);
			m_ListBox.InsertString(0,strTemp);

		}
	}
	else
	{
		byBeginFlag=1;
	}

	*pResult = 0;
}

void CAviSearchingTimeDlg::ShowImage(long lNum)
{
	//to get the data of the bitmap
	m_lpBMPInfoHeader = (LPBITMAPINFOHEADER)AVIStreamGetFrame(m_pGetFrame,lNum);

	//loading the bmp file by CXimage.
	if(m_lpBMPInfoHeader->biBitCount<=8)
		m_Ximage.Decode((BYTE*)m_lpBMPInfoHeader,m_lpBMPInfoHeader->biSizeImage+sizeof(BITMAPINFOHEADER)+(WORD)pow(2,m_lpBMPInfoHeader->biBitCount)*sizeof(RGBQUAD),CXIMAGE_FORMAT_BMP);
	else
		m_Ximage.Decode((BYTE*)m_lpBMPInfoHeader,m_lpBMPInfoHeader->biSizeImage+sizeof(BITMAPINFOHEADER),CXIMAGE_FORMAT_BMP);

	//draw the Ximage.
	if (m_Ximage.IsValid())
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC);
		CDC* pDC = pWnd->GetDC();

		CRect rect;
		pWnd->GetClientRect(&rect);
		m_Ximage.Draw(pDC->m_hDC, rect, NULL);
	}

}

void CAviSearchingTimeDlg::AviInit(CString strAviFileName)
{
	HRESULT hr;

	AVIFileInit();

 	//open the avi file,
	hr=AVIFileOpen(&m_pAviFile,
		strAviFileName,
		OF_READ,
		NULL);
	if(hr!=0)
		MessageBox("error in AVIFileOpen");

	//get the information of avi file, 
	hr = AVIFileInfo(m_pAviFile,
		&m_pAviFileInfo,
		sizeof(AVIFILEINFO)
		);
	if(hr!=0)
		MessageBox("error in AVIFileInfo");

	//get the stream from avi file.
	hr = AVIFileGetStream(
		m_pAviFile,
		&m_pAviStream,
		streamtypeVIDEO,
		0);
	if(hr!=0)
		MessageBox("error in AVIFileGetStream");

	//get the stream's infomation
	hr=AVIStreamInfo(m_pAviStream,
		&m_AviStreamInfo,
		sizeof(AVISTREAMINFO)
		);
	if(hr!=0)
		MessageBox("error in AVIStreamInfo");

	//get the Stream's poiter
	m_pGetFrame = ::AVIStreamGetFrameOpen(m_pAviStream,NULL);
	if(!m_pGetFrame)
		MessageBox("error in AVIStreamGetFrameOpen");

}

void CAviSearchingTimeDlg::OnOK() 
{
	// TODO: Add extra validation here
//	m_Ximage.Destroy();
//	free(m_pAviFile);
//	free(m_pAviStream);
	AVIFileExit();

	CDialog::OnOK();
}
